#ifndef _DEFINECONSTANT_H
#define _DEFINECONSTANT_H

#define ON						1
#define OFF						0
#define FW						1
#define BW						0
#define UP						1
#define DN						0

// For Loader
#define MAX_PORT_NO				3
#define	MAX_SLOT_NO				28	// 20100629 ssm
#define MAX_LOADER_IF_NO		5	// ljy_050128 : for maint Loader I/F Signal off and restore.

// For Sub-Unit (Main Equipment)

#define MAX_CV_NO				8//13khs	//  Conveyor SvSeq.cpp  UNIT Conv  ϰų и   ִ.   Unit и
#define MAX_CV_MOTOR_NO			11			//  CV Motor
#define MAX_RB_NO				8//4//khs	// Roll Brush Motor
#define MAX_RB_GAP_SERVO_NO		8//4//khs	// Roll Brush Gap Servo Motor.
#define MAX_RB_PART				4			// Unit  RB ִ . 2 ̻ Unit RB    .  Unit  RB  ٸ    .
//#ifndef _NO_RB
#define MAX_PARTS_NO			20 // 240614 halesu 18//9//khs
// #else
// #define MAX_PARTS_NO			5
// #endif
#define MAX_MUX10				2
#define MAX_MUX10_CHANNEL		4
#define MAX_MUX10_RECV_LENGTH	13

//--BUF TANK--//		// 231220 halesu define NG Fix
#define MAX_DI_BUFTANK_NO		1//1 khs
#define MAX_DI_BUFTANK_AUTOVALVE	7	//200412 hskwak Buf Tank Add
#define MAX_BUFTANK_LEAK_SENSOR_NO	1
#define MAX_DI_BUFTANK_PUMP_NO	2
#define MAX_DI_BUFTANK_LEVEL_NO	4		//200412 hskwak Buf Tank Add
#define MAX_DI_BUFTANK_NO		1		//200412 hskwak Buf Tank Add
#define NO_BUFTANK			2
#define NO_BUFTANK_LEAK		6			// 231219 halesu SWR2(2)+SWR3(2)+AK(2)+BUFTank(1)
//------------//

#ifdef _BUFTANK_USE
#define MAX_DI_TANK_NO			3//1 khs
#define MAX_DI_PUMP_NO			4//1 khs
#else
#define MAX_DI_TANK_NO			2//1 khs
#define MAX_DI_PUMP_NO			2//1 khs
#endif

#define MAX_DI_TANK_LEVEL_NO	4		//190501 ksh
#define MAX_DI_TANK2_LEVEL_NO	4		//190501 ksh

#define MAX_CLN_TANK_NO	2				//190501 ksh

#ifdef _BUFTANK_USE
#define MAX_JOB3_VIEW_PUMP_NO   2		//190501 ksh
#define MAX_JOB3_VIEW_TANK_NO	2		//190501 ksh
#else
#define MAX_JOB3_VIEW_PUMP_NO   1		//190501 ksh
#define MAX_JOB3_VIEW_TANK_NO	1		//190501 ksh
#endif
#define MAX_JOB3_VIEW_PUMP2_NO  1		//190501 ksh
#define MAX_JOB3_VIEW_TANK2_NO	1		//190501 ksh
#define MAX_JOB4_VIEW_PUMP_NO	2		//200413 hskwak Buf Tank Add
#define MAX_JOB4_VIEW_BUFTANK_NO	1		//200413 hskwak Buf Tank Add

#define MAX_HOT_DI_TANK_NO		1
#define MAX_DI_HEATER_NO		1
#define MAX_DI_FLOW_INTERLOCK	3		//6//4

// For DicsDetPumpSeq
#define MAX_CHEMICAL_TYPE_NO		1
#define MAX_DET_UNIT_NO				1
#define MAX_DET_UNIT_MIX_TANK_NO	2
#define MAX_DET_UNIT_HEATER_NO		2
#define MAX_DET_UNIT_CIR_PUMP_NO	2
#define MAX_MIX_TANK_NO				( MAX_DET_UNIT_NO*MAX_DET_UNIT_MIX_TANK_NO )
#define MAX_DET_VALVE_NO			12
#define MAX_DET_TANK_NO				2
#define MAX_DET_PUMP_NO				3
#define MAX_DET_SUP_PUMP_NO			2
#define MAX_HEATER_NO				2

// For CimSeq of HSMS
#define MAX_CEID_NO				23  // CEID Data
#define MAX_ECID_NO				9	// Constant Data : ECID
#define MAX_ECV_NO				24	//  Item 
#define MAX_TRID_NO				10  // Trace Data
#define MAX_SAMPLE_NO			20
#define MAX_SV_NO				17
#define MAX_CEV_NO				50
#define MAX_RCP_NO				99
#define MAX_EQP_UNIT_NO			2
#define MAX_GLASS_DV_NO			18  // Glass DV
#define MAX_LOT_DV_NO			16  // Lot DV
#define MAX_ALARM_REPORT_NO		10  // Alarm Report
#define	MAX_USING_SLOT_NO		25

#define MAX_STOP_COUNT_NO		10

#define MAX_IF_NO				8//11khs
#define MAX_UNIT_NO				8//11khs

#define UNIT_TACKTIME			1	// hskwak 191011 Unit  tack time ߰. 

#define MAX_IN_SENSOR_NO		8//5khs
#define MAX_OUT_SENSOR_NO		8//5khs
#define MAX_IN_OUT_SENSOR_NO    2  // In Sensor 1EA Out Sensor 1EA
#define MAX_GLS_EXIST_SENSOR_NO 2 * MAX_UNIT_NO
#define MAX_GLS_BROKEN_SENSOR_NO		4	// Broken Sensor.
#define MAX_GLS_INTERLOCK_SENSOR_NO		2	// Robot hand
#define MAX_GLS_ACCEL_SENSOR_NO	2	// Accel Sensor
#define MAX_GLS_DECEL_SENSOR_NO 2	// decel Sensor
#define MAX_SCAN_NO				2	//khs	// Broken Scan

#define BS_UNIT_UL				0	// Broken Scan Unit Unload
#define BS_UNIT_LD				1	// Broken Scan Unit Load

#define MAX_BATH_NO				4//10 khs
#define MAX_EMO_NO				12//14 khs	
#define MAX_EMS_NO				1
#define MAX_DIALARM_NO			4
#define MAX_ESD_ALM_NO			3

#define MAX_COVER_OPEN_NO		16//9 khs	// Bath Cover Sensor
#define MAX_IONIZER_NO			2//5 khs
#define MAX_IONIZER_ALM_NO		3
#define MAX_FFU_NO				7//10 khs
#define MAX_LEAK_SENSOR_DISPLAY_NO	6   //3 //4 khs // 151120 halesu
#define MAX_LEAK_SENSOR_NO		6   //3 //8 khs // 151120 halesu 3 -> 6
#define MAX_DOOR_OPEN_NO		44//109 khs	// SanghoCho 2015.03.17

#ifdef _BUFTANK_USE
#define MAX_VALVE_NO			23//8 khs	// 130812 halesu 14 --> 15	
#else
#define MAX_VALVE_NO			19//8 khs	// 130812 halesu 14 --> 15	
#endif
#define MAX_ALIGN_NO			4
#define MAX_ANALOG_IN_NO		60//32 khs // minhanx 080922 28	̻

#define MAX_LF_VIEW_AI_NO		27		//JobsTabMotorLoadFactorView

#ifdef _BUFTANK_USE
#define MAX_AI_INTR_NO			93//30//27
#else
#ifdef _MOTOR_LOAD_FACTOR
#define MAX_AI_INTR_NO			87//30//27
#else
#define MAX_AI_INTR_NO			60//30//27
#endif
#endif

#define MAX_SBJ_NO				2//2 khs
//#define MAX_TRACE_DATA_NO		33	// 150901 halesu 6 + 3 ( RECIPE ) + 24 (AI)	 67	//2008.11.03 kimgun
#define MAX_RECIPE_CIM_DATA_NO	35

#ifdef _MOTOR_LOAD_FACTOR
#define MAX_TRACE_DATA_NO		32+39+ MAX_AI_INTR_NO + MAX_RECIPE_CIM_DATA_NO 	// Glass(4), AI(60), Status(39)   // 150901 halesu 6(Glass Info) + 19 ( RECIPE ) + 31 (AI)	 67	//2008.11.03 kimgun
#else
#define MAX_TRACE_DATA_NO		43 + MAX_AI_INTR_NO + MAX_RECIPE_CIM_DATA_NO	// Recipe(1), AI(60), Status(39)   // 150901 halesu 6(Glass Info) + 19 ( RECIPE ) + 31 (AI)	 67	//2008.11.03 kimgun
#endif

#define MAX_TRACE_MULTI_NO		20	//atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupMAX_GLASS_NO] )
#define MAX_GLS_APD_NO			44	//19

#define	MAX_IF_LOADER_EMO		1

// Set Deinfe
#define MAX_EUV_ALARM			12
#define MAX_LAMP_NO				4
#define MAX_LAMP_CONTROL_NO		4
#define MAX_LAMP_INTENSITY_NO	4
#define MAX_EUV_UTIL_ALARM		3

////////// HPMJ  MAX Define HJYOU 2007.11.28
#define MAX_WATERJET_AI_NO		7
#define MAX_HPMJ_ALARM_NO		4
#define MAX_HPMJ_AI_INTRO_NO	8
#define HPMJ_AI_START_NO		4
#define HPMJ_FILTER_DIFF_NO		7
#define MAX_HPMJ_STATE_DATA		9
///////////////////////////////////////////////////////////////////////////////////////
//AP 
#define MAX_AP_ALARM			23 //2008.07.22 kimgun	
//---------------------------------------------------------------------------
// AP PLASMA RF Generator
//---------------------------------------------------------------------------
#define FORWARD					0
#define REFLECTED				1
#define MAX_RFG_AI_NO			3  //RF Generator


#define SPEED_INTEVAL			300

#define MAX_GLASS_DATA_ITEM_NO	6	//10 hskwak 

#define DI_PUMP_INTERLOCK_MIN_FLOWRATE	atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupPUMP_INTERLOCK_FLOW_RATE] )		// lpm
#define PUMP_FLOW_LIMIT_CHECK_TIME		atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupPUMP_INTERLOCK_CHECK_TIME] )		// mSec

// User auto change time.
#define USER_AUTO_CHANGE		10

// Define the color
#define WHITE_COLOR				RGB(255, 255, 255)
#define LIGHT_GRAY				RGB(212, 208, 200)
#define GRAY_COLOR				RGB(192, 192, 192)
#define DARK_GRAY_COLOR			RGB(130, 130, 130)
#define BLACK_COLOR				RGB(0, 0, 0)
#define BG_COLOR				RGB(230, 230, 230)

#define RED_COLOR				RGB(255, 0, 0)
#define LIGHT_RED_COLOR			RGB(255, 190, 190)
#define DARK_RED_COLOR			RGB(190, 0, 0)

#define GREEN_COLOR				RGB(0, 255, 0)
#define LIGHT_GREEN_COLOR		RGB(190, 255, 190)
#define DARK_GREEN_COLOR		RGB(0, 190, 0)

#define BLUE_COLOR				RGB(0, 0, 255)
#define LIGHT_BLUE_COLOR		RGB(190, 190, 255)
#define BASE_BG_COLOR			RGB(212, 208, 200)		//ljy_041009
//#define LESS_BLUE_COLOR			RGB(150, 150, 255)

#define CYAN_COLOR				RGB(0, 255, 255)
#define LIGHT_CYAN_COLOR		RGB(190, 255, 255)

#define MAGENTA_COLOR			RGB(255, 0, 255)
#define LIGHT_MAGENTA_COLOR		RGB(255, 190, 255)

#define YELLOW_COLOR			RGB(255, 255, 0)
#define LIGHT_YELLOW_COLOR		RGB(255, 255, 190)
#define DARK_YELLOW_COLOR		RGB(190, 190, 0)

#define ORANGE_COLOR			RGB(250, 170, 0)
#define LIGHT_ORANGE_COLOR		RGB(255, 220, 100)
#define MAP_NO_GLASS_COLOR		RGB(220, 220, 220)

// Use for CRecipesTab1View & CRecipesTab2View classes
#define BG_COLOR_DISABLE	BG_COLOR
#define BG_COLOR_INT		WHITE_COLOR
#define BG_COLOR_BOOL_ON	GREEN_COLOR
#define BG_COLOR_BOOL_OFF	LIGHT_GREEN_COLOR

// Define Windows Timer
#define	TIMER_CUR_TIME			40
#define	TIMER_CV_GLASS_MOVE		41
#define	TIMER_IO_TEST			42
#define	TIMER_MANUAL			43
#define TIMER_TACT_TIME			44
#define TIMER_UPDATE_VIEW		45
#define TIMER_SOCKET_OPEN		46
#define TIMER_LOADER			47
#define TIMER_UNLOADER			48
#define TIMER_HEATER			49
#define	TIMER_MAINFRM			50
#define TIMER_USER_CHECK		51
#define TIMER_CURSOR_CHECK      52
#define TIMER_INTERFACE_MONITOR	53
#define TIMER_COMM_FLOW_METER	54
#define TIMER_COMM_FLOW_METER2	55
#define TIMER_POWER_FLOW_METER	56			// 20100708 ssm
#define TIMER_IO_DO				57
#define TIMER_UNIT_TACKTIME		58
#define TIMER_ROBOT(A)			59+A						// A => ServoView,TabViews,,,SemiAutoView

// Define Sequence Timer ID
#define TM_IN_SENSOR_ON(A)		( 0 * MAX_UNIT_NO + (A) )		// 0,   1,  2,  3,  4,  5,  6,  7,  8,  9,
#define TM_IN_SENSOR_OFF(A)		( 1 * MAX_UNIT_NO + (A) )		// 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
#define TM_IN_SENSOR_IN2OUT(A)	( 2 * MAX_UNIT_NO + (A) )		// 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 
#define TM_OUT_SENSOR_ON(A)		( 3 * MAX_UNIT_NO + (A) )		// 30, 31, 32, 33, 34, 35, 36, 37, 38, 39,
#define TM_OUT_SENSOR_OFF(A)	( 4 * MAX_UNIT_NO + (A) )		// 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
#define TM_OUT_SENSOR_OUT2IN(A)	( 5 * MAX_UNIT_NO + (A) )		// 50, 51, 52, 53, 54, 55, 56, 57, 58, 59

#define CUR_TM_COUNT1			( 6 * ( MAX_UNIT_NO ) + 1 )

#define	TM_SEQ_INIT				( CUR_TM_COUNT1 + 0 )
#define	TM_SEQ_INIT_CV			( CUR_TM_COUNT1 + 1 )
#define	TM_SEQ_INIT_TR			( CUR_TM_COUNT1 + 2 )
#define TM_SEQ_EMO				( CUR_TM_COUNT1 + 3 )
#define TM_GLASS_RECV			( CUR_TM_COUNT1 + 4 )
#define TM_GLASS_SEND			( CUR_TM_COUNT1 + 5 )
#define TM_TR_ALIGN				( CUR_TM_COUNT1 + 6 )
#define TM_TR_TURN				( CUR_TM_COUNT1 + 7 )
#define TM_LOADER_INIT			( CUR_TM_COUNT1 + 8 )
#define TM_APD_DATA				( CUR_TM_COUNT1 + 9 )
#define	TM_SEQ_INIT_RB(A)		( CUR_TM_COUNT1 + 10 + (A) ) 
#define	TM_SEQ_INIT_CV1			( CUR_TM_COUNT1 + 20 )
#define CUR_TM_COUNT2			( TM_SEQ_INIT_CV1 + 1 )

#define TM_LOADER_PORT_MODE(A)	( CUR_TM_COUNT2 + ( 3 * 0 ) + (A) )	// ?????/ ؼ ־   41, 42, 43
#define TM_LOADER_TRS_MODE(A)	( CUR_TM_COUNT2 + ( 3 * 1 ) + (A) )	// 44, 45, 46
#define TM_LOADER_CST_LOAD(A)	( CUR_TM_COUNT2 + ( 3 * 2 ) + (A) )	// 47, 48, 49
#define TM_LOADER_CST_UNLOAD(A)	( CUR_TM_COUNT2 + ( 3 * 3 ) + (A) )	// 50, 51, 52

#define CUR_TM_COUNT3			( TM_LOADER_CST_UNLOAD(2) + 1 )

#define TM_LOADER_ROBOT			( CUR_TM_COUNT3 + 0 )
#define TM_LOADER_ROBOT_LD		( CUR_TM_COUNT3 + 1 )
#define TM_LOADER_ALARM			( CUR_TM_COUNT3 + 2 )
#define TM_LOADER_MANUAL		( CUR_TM_COUNT3 + 3 )
#define TM_SEQ_DI_TANK(A)		( CUR_TM_COUNT3 + 4 + (A) ) // 4, 5
#define TM_SEQ_DIW_IDLE			( CUR_TM_COUNT3 + 6 )
#define TM_EUV_MONITOR			( CUR_TM_COUNT3 + 7 )
#define TM_EUV_SENSOR_MOVE		( CUR_TM_COUNT3 + 8 )
#define TM_JOINT				( CUR_TM_COUNT3 + 9 )
#define TM_EUV_ON				( CUR_TM_COUNT3 + 10 )
#define TM_EUV_PROGRESS			( CUR_TM_COUNT3 + 11 )
#define TM_UP_CV_STOP           ( CUR_TM_COUNT3 + 12 )
#define TM_UL_CV_STOP			( CUR_TM_COUNT3 + 13 )
#define TM_AP_MONITOR			( CUR_TM_COUNT3 + 14 )
#define TM_AP_PROGRESS			( CUR_TM_COUNT3 + 15 )
#define TM_HPMJ_PUMP_CONTROL	( CUR_TM_COUNT3 + 16 )
#define TM_HPMJ_PID_TIME_OVER	( CUR_TM_COUNT3 + 17 )
#define TM_LD1_IN_SENSOR_ON     ( CUR_TM_COUNT3 + 18 ) // 2009.03.09 minhan
#define TM_LD1_IN_SENSOR_OFF    ( CUR_TM_COUNT3 + 19 ) // 2009.03.09 minhan
#define TM_LD1_IN_SENSOR_IN2OUT ( CUR_TM_COUNT3 + 20 ) // 2009.03.09 minhan

#define MAX_TIMER_NO			( TM_LD1_IN_SENSOR_IN2OUT + 1 ) // 2009.03.09 minhan
//#define MAX_TIMER_NO			( TM_HPMJ_PID_TIME_OVER + 1 )

// Window Messages
#define WM_BTN_PUSHED			WM_USER + 101
#define WM_BTN_RELEASED			WM_USER + 102
#define WM_MSG_BOX_CLICKED		WM_USER + 103

#define WM_JOBS_VIEW			WM_USER + 201
#define WM_SETUP_VIEW			WM_USER	+ 202
#define WM_JOBS_VIEW_SELECT_TAB	WM_USER + 203

#define WM_EQP_LOG				WM_USER + 210
#define WM_EQP_MESSAGE			WM_USER + 211
#define WM_HOST_LOG				WM_USER + 212
#define WM_ALARM				WM_USER + 213
#define WM_GLASS_NO				WM_USER + 214
#define WM_TACT_TIME			WM_USER + 215
#define WM_SET_RECIPE			WM_USER + 216
#define WM_DET_IDLE_RUNNING_PROGRESS	WM_USER + 217
#define WM_DIW_IDLE_RUNNING_PROGRESS	WM_USER + 218

#define WM_VALVE_STATUS_CHANGED	WM_USER + 220
#define WM_EQP_STATUS_CHANGED	WM_USER + 222
#define WM_LD_STATUS_CHANGED	WM_USER + 223
#define WM_SENSOR_STATUS_CHANGED		WM_USER + 224
#define WM_BROKEN_SENSOR_STATUS_CHANGED	WM_USER + 225
#define WM_BROKEN_SCAN_STATUS_CHANGED	WM_USER + 226

// For Loader I/F
#define WM_COMM_SEND_MSG		WM_USER + 227
#define WM_COMM_RCVD_MSG		WM_USER + 228

// For CIM I/F
#define WM_AP_ON_PROGRESS		WM_USER + 229
#define WM_EDIT_CSTID_INFO		WM_USER + 230
#define WM_EDIT_PORT_INFO		WM_USER + 231
#define WM_SET_EUV_TIME			WM_USER + 232
#define WM_EUV_ON_PROGRESS		WM_USER + 233

#define WM_SOCKET_OPEN			WM_USER + 234

#define WM_AI1_VALUE			WM_USER + 235
#define WM_LEAK_SENSOR			WM_USER + 236
#define WM_COVER_OPEN			WM_USER	+ 237
#define WM_LD_DOOR_OPEN			WM_USER + 238	// ljy_050406 : add
#define WM_UL_DOOR_OPEN			WM_USER + 239	// ljy_050406 : add
#define WM_INIT_STATUS			WM_USER + 240
#define WM_POSITION_SENSOR_STATUS_CHANGED		WM_USER + 241	// ljy_050502 : add
#define WM_CIM_INTERFACE_VIEW	WM_USER + 242	// EUN_060208

// Tank Level Photo Sensor Type
#define WM_TANK_STATUS_CHANGED				WM_USER + 243
#define WM_TANK_HH_STATUS_CHANGED			WM_USER + 244
#define WM_TANK_H_STATUS_CHANGED			WM_USER + 245
#define WM_TANK_M2_STATUS_CHANGED			WM_USER + 246
#define WM_TANK_M1_STATUS_CHANGED			WM_USER + 247
#define WM_TANK_L_STATUS_CHANGED			WM_USER + 248
#define WM_TANK_LL_STATUS_CHANGED			WM_USER + 249

// Pump Status 
#define WM_PUMP_STATUS_CHANGED				WM_USER + 250
#define WM_TR_POS_SENSOR_STATUS_CHANGED		WM_USER + 251
#define WM_TR_AREA_SENSOR_STATUS_CHANGED    WM_USER + 252
#define WM_AGING_MODE_STATUS_CHANGED		WM_USER + 253
#define WM_LOST_GLASS_ADD					WM_USER + 254		
#define WM_LOST_GLASS_RECOVERY				WM_USER + 255		
#define WM_RECIPE_ID_DELETE					WM_USER + 256
#define WM_EDC_DATA_CHANGED					WM_USER + 257
#define WM_APD_DATA_CHANGED					WM_USER + 258
#define WM_EUV_COMM							WM_USER + 259				
#define WM_TEST_MODE_SET					WM_USER + 260
#define WM_SOCKET_OPEN1						WM_USER + 261
#define WM_ESD_STATUS_CHANGED				WM_USER + 262
				
// About WM_JOB_VIEW
#define PROGRESS_START			0
#define PROGRESS_END			1
#define PROGRESS_SET			2

// Sub Message for WM_EQP_MESSAGE
#define MSG_DEVICENET_STATE		0
#define MSG_UP_STREAM_STATE		1
#define MSG_DN_STREAM_STATE		2
#define MSG_TITLEBAR_MESSAGE	3
#define MSG_EQP_MESSAGE			4
#define MSG_HOST_STATE			5
#define MSG_UP_STREAM_STATE1	6
#define MSG_MELSEC_UNLOAD_STATE	7

#define MSG_CTRL_MODE			0
#define MSG_PORT_MODE			1
#define MSG_TRS_MODE			2
#define MSG_PORT_STATE			3
#define MSG_TERMINAL_MESSAGE	4
#define MSG_TERMINAL_WARNING	5
#define MSG_CIM_MESSAGE			6
#define MSG_GLASS_COUNT			7
#define MSG_LOADER_MODE			8
#define MSG_HOST_WARNING		9
#define	MSG_HOST_WARNING1		10
#define	MSG_HOST_TIMEOUT		11
// Sub Message for WM_INIT_STATUS
#define MSG_STATUS_START		0
#define MSG_STATUS_OK			1
#define MSG_STATUS_NG			2
#define MSG_STATUS_SERVO_ESTOP	3
#define MSG_STATUS_SERVO_RESET	4
#define MSG_STATUS_SERVO_HOME	5
#define MSG_STATUS_NO_USE		6
#define MSG_STATUS_SET_OK		7

#define MSG_STATUS_DLG_CREATE	0
#define MSG_STATUS_DLG_DESTROY	1
#define MSG_STATUS_SET_MAIN		2
#define MSG_STATUS_RESET_MAIN	3
#define MSG_STATUS_SET_PUMP1	4
#define MSG_STATUS_SET_PUMP2	5
#ifdef _BUFTANK_USE
#define MSG_STATUS_SET_PUMP3	6
#define MSG_STATUS_SET_PUMP4	7
#define MSG_STATUS_RESET_PUMP1	8
#define MSG_STATUS_RESET_PUMP2	9
#define MSG_STATUS_RESET_PUMP3	10
#define MSG_STATUS_RESET_PUMP4	11
#define MSG_STATUS_SET_READY	12
#define MSG_STATUS_RESET_READY	13
#else
#define MSG_STATUS_RESET_PUMP1	6
#define MSG_STATUS_RESET_PUMP2	7
#define MSG_STATUS_SET_READY	8
#define MSG_STATUS_RESET_READY	9
#endif

// Sub Message for WM_CIM_INTERFACE_VIEW
#define MSG_READY_TO_LD_SEND	0
#define MSG_READY_TO_EQP_RECV	1
#define MSG_PUTTING				2
#define MSG_ARM_INTERFERE_OK_LD	3
#define MSG_ARM_INTERFERING_LD	4
#define MSG_GLASS_DATA_READ_LD	5
#define MSG_PUT_COMP			6
#define MSG_LD_INTERFACE_CLEAR	7

#define MSG_READY_TO_EQP_SEND	0
#define MSG_READY_TO_LD_RECV	1
#define MSG_GETTING				2
#define MSG_GLASS_DATA_SEND_UL	3
#define MSG_ARM_INTERFERE_OK_UL	4
#define MSG_ARM_INTERFERING_UL	5
#define MSG_GET_COMP			6
#define MSG_UL_INTERFACE_CLEAR	7

#define MSG_GLASS_LD			0
#define MSG_GLASS_UL			1
#define MSG_GLASS_EXCHANGE		2

// Sub Message for WM_CIM_INTERFACE_VIEW
#define MSG_HDC_LD_REQ			0
#define MSG_READY_LD_STAGE		1
#define MSG_HDC_ACCESS_PBL_LD	2
#define MSG_RBT_ACCESS_LD		3
#define MSG_RCV_DATA_READ_REQ	4
#define MSG_RCV_DATA_READ_COMP	5
#define MAX_LD_MSG				6

#define MSG_HDC_UL_REQ			10
#define MSG_READY_UL_STAGE		11
#define MSG_HDC_ACCESS_PBL_UL	12
#define MSG_RBT_ACCESS_UL		13
#define MSG_REP_DATA_READ_REQ	14
#define MSG_REP_DATA_READ_COMP	15

// About WM_ALARM
#define	ALARM_SET				0
#define	ALARM_RESET				1
#define	ALARM_RESET_ALL			2

// About WM_ALARM
#define SET_ALARM				0
#define RESET_ALARM				1
#define RESET_ALL				2

// CV Unit Interface No
#define IF_UNIT_LD				0
#define IF_UNIT_SWR1				1
#define IF_UNIT_SWR2				2
#define IF_UNIT_SWR3				3
#define IF_UNIT_SWR4				4
#define IF_UNIT_AK				5
#define IF_UNIT_BUF				6
#define IF_UNIT_UL				7
//#define IF_UNIT_EUV				1000	// BUF3
//#define IF_UNIT_RB				1000	// SWR1
//#define IF_UNIT_FR				1000	// SWR2
#define TRACE_START_UNIT		IF_UNIT_LD

#define CV_NO_LD				0
#define CV_NO_SW1				1
#define CV_NO_SW2				2
#define CV_NO_SW3				3
#define CV_NO_SW4				4
#define CV_NO_AK				5
#define CV_NO_BUF				6
#define CV_NO_UL				7


#define CV_MOTOR_NO_LD			0
#define CV_MOTOR_NO_SWR1		1
#define CV_MOTOR_NO_SWR2_1		2
#define CV_MOTOR_NO_SWR2_2		3
#define CV_MOTOR_NO_SWR3_1		4
#define CV_MOTOR_NO_SWR3_2		5
#define CV_MOTOR_NO_SWR4		6
#define CV_MOTOR_NO_AK1			7
#define CV_MOTOR_NO_AK2			8
#define CV_MOTOR_NO_BUF			9
#define CV_MOTOR_NO_UL			10


// Mechanical Parameter
#define PI					3.141592
//#define ROLLER_DIA		60.0
//#define ROLLER_DIA_LARGE	150.0		// ljy_050317 : change 150.0 (135)		//kjd

// (A) / 60.0 : A mm/sec
// 0x4000 : 5V = 3000 rpm
// PI * ROLLER_DIA : length of circle
// 50.0 : 50 rev/sec = 3000 rpm
// 
//							0x4000	
//	AO = -------------------------------------------- * V (mm/min)
//		 60(sec)*50(rev)*Pi*D(Diameter)*R(Gear Ratio)
//
//					1
//	# R = --------------------
//			ROLLER_GEAR_RATIO
#define ROLLER_GEAR_RATIO(A)			m_pSetupItems->m_fValueCvMotorRatio[A]
#define ROLLER_GEAR_DIA(A)				m_pSetupItems->m_fValueCvMotorDia[A]
#define ROLLER_VEL_RATIO(A)				m_pSetupItems->m_fValueCvMotorVelRatio[A]
#define CV_SPEED_2_AO_ORG(A,B)		( (B) * 0x4000 * ROLLER_VEL_RATIO(A) ) / ( PI * ROLLER_GEAR_DIA(A) * 3000.0 / ROLLER_GEAR_RATIO(A) )

#define CV_SPEED_2_AO(A,B)			( ( (A) == IF_UNIT_LD )		? CV_SPEED_2_AO_ORG( 0, B ) : \
									  ( (A) == IF_UNIT_SW1 )	? CV_SPEED_2_AO_ORG( 1, B ) : \
									  ( (A) == IF_UNIT_SW2 )	? CV_SPEED_2_AO_ORG( 2, B ) : \
									  ( (A) == IF_UNIT_SW3 )	? CV_SPEED_2_AO_ORG( 3, B ) : \
									  ( (A) == IF_UNIT_SW4 )	? CV_SPEED_2_AO_ORG( 4, B ) : \
									  ( (A) == IF_UNIT_AK )		? CV_SPEED_2_AO_ORG( 5, B ) : \
									  ( (A) == IF_UNIT_BUF )	? CV_SPEED_2_AO_ORG( 6, B ) : \
									  ( (A) == IF_UNIT_UL )		? CV_SPEED_2_AO_ORG( 7, B ) : \


#define RB_SPEED_2_AO(A)				( ( (A) * 0x4000 / 3000.0 ) * 5 )
#define TIMEOUT_MARGIN_ON				3.0		// unit : sec
#define TIMEOUT_MARGIN_OFF				3.0		// unit : sec
#define DELAY_TIME						2.0		// unit : sec

#define GLASS_SIZE						atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupGLASS_SIZE] )

#define TIMEOUT_MARGIN_LENGTH_ON		atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupCV_TIMEOUT_DISTANCE] )
#define TIMEOUT_MARGIN_LENGTH_OFF		atoi( m_pSetupItems->m_sValueSetup[CSetupItems::setupCV_TIMEOUT_DISTANCE] )

#define LD_GLS_INTERLOCK_SENSOR_DISTANCE	1300.0	// mm
#define UL_GLS_INTERLOCK_SENSOR_DISTANCE	300.0	// mm

// Etc
#define ABS(A)					( (A) < 0 ? -(A) : (A) )

#define GLASS_CHANGING_VEL	30.0	
// Servo
#define MAX_RBT_AXES	4    // x, y, z , 0(theta)

#define RBT_S1_MOVE		0	// S-move (  ȵ)
#define RBT_S2_MOVE		1	// S-move (  )
#define RBT_T1_MOVE		2	// Trapezoidal move (  ȵ)
#define RBT_T2_MOVE		3	// Trapezoidal move (  )
#define RBT_C_MOVE		4	// Coordinated move

#define HOME_SENSOR_AND_INDEX		0
#define HOME_SENSOR_ONLY			1
#define HOME_MECHANICAL_HARD_STOP	2

#define RETRY_NO			3
#define IN_POSITION_VALUE	3.0 

#define MODE_NONE			0
#define MODE_AGING			1
#define MODE_CLEAN_OUT		2
#define MODE_UL_TIME_OUT	3

// Define
#define MAX_EQP_STATE_NO	11
#define MAX_EQP_GLASS_NO	4	// ljy_050419

#define MAX_LOT_APD_NO		27
#define MAX_EDC_DATA_NO		12

#ifdef _MOTOR_LOAD_FACTOR
#define MAX_APD_DATA_NO		103 + MAX_RECIPE_CIM_DATA_NO + MAX_LF_VIEW_AI_NO		//103+27 //35//28	//hskwak APD Data  
#else
#define MAX_APD_DATA_NO		103 + MAX_RECIPE_CIM_DATA_NO	//35//28	//hskwak APD Data  
#endif

#define MAX_APD_STATUS_DATA_DI_NO	21 // hskwak 190812 ߰ APD Data  (Digital Input)  .
#define MAX_APD_STATUS_DATA_GAP_NO	8 // hskwak 190812 ߰ APD Data  (GAP)  .
#define MAX_APD_STATUS_DATA_PIMTIME_NO	2 // hskwak 190812 ߰ APD Data  PIMTIME  .
#define MAX_APD_STATUS_DATA_TACKTIME_NO	8 // hskwak 190812 ߰ APD Data  PIMTIME  .
#define MAX_APD_STATUS_DATA_IO_NO	39 // hskwak 190812 ߰  APD Data  (DI, Gap, Time)  .
// Password
#define	MAX_ACCOUNT_NO			10

// 񸶴 Ҽ ִ 
#define ACC_VALUE			15		//  ð (150 msec)


#define MAX_AXES_HAND_NO	0 //1 //SPARE AXIS ADD
#define MAX_AXES_RB_NO		8


#define MAX_AXES			(MAX_AXES_HAND_NO+MAX_AXES_RB_NO)		// ljy_050425 : change 11 -> 10, Multi board => 8 card + 4  Card
#define MAX_RBT_NO			(MAX_AXES_HAND_NO+MAX_AXES_RB_NO)		// ljy_050425 : change 8 -> 7
#define MAX_TR_RBT_NO		0

#define AXIS_X					0
#define AXIS_Y					1
#define AXIS_Z					2
#define AXIS_THETA				3

#define SWR2_RBT_RB_UNIT_UP_RB1_UNIT	0
#define SWR2_RBT_RB_UNIT_LO_RB1_UNIT	1
#define SWR2_RBT_RB_UNIT_UP_RB2_UNIT	2
#define SWR2_RBT_RB_UNIT_LO_RB2_UNIT	3
#define SWR3_RBT_RB_UNIT_UP_RB1_UNIT	4
#define SWR3_RBT_RB_UNIT_LO_RB1_UNIT	5
#define SWR3_RBT_RB_UNIT_UP_RB2_UNIT	6
#define SWR3_RBT_RB_UNIT_LO_RB2_UNIT	7

#define ANI_TR_UNIT				0
#define ANI_LD_UP_HAND_UNIT		1
#define ANI_LD_LO_HAND_UNIT		2
#define ANI_UL_LO_HAND_UNIT		3
#define ANI_UL_UP_HAND_UNIT		4

#define IF_SEMI_CV				0
#define IF_SEMI_LD_UPDN			1
#define IF_SEMI_LD				2

#define RBT_SWR2_UP_RB1_UNIT_S_AXIS	0		// RBT_SW2_UP_RB1_UNIT  : Z
#define RBT_SWR2_LO_RB1_UNIT_S_AXIS	1		// RBT_SW2_LO_RB1_UNIT  : Z
#define RBT_SWR2_UP_RB2_UNIT_S_AXIS	2		// RBT_SW2_UP_RB2_UNIT  : Z
#define RBT_SWR2_LO_RB2_UNIT_S_AXIS	3		// RBT_SW2_LO_RB2_UNIT  : Z
#define RBT_SWR3_UP_RB1_UNIT_S_AXIS	4		// RBT_SW3_UP_RB1_UNIT  : Z
#define RBT_SWR3_LO_RB1_UNIT_S_AXIS	5		// RBT_SW3_LO_RB1_UNIT  : Z
#define RBT_SWR3_UP_RB2_UNIT_S_AXIS	6		// RBT_SW3_UP_RB2_UNIT  : Z
#define RBT_SWR3_LO_RB2_UNIT_S_AXIS	7		// RBT_SW3_LO_RB2_UNIT  : Z

#define MAX_RBT_LD_UPDN_UNIT_POS_NO		3
#define MAX_RBT_UL_HAND_UNIT_POS_NO		4
#define MAX_RBT_RB_UNIT_POS_NO			2

// LD UPDN UNIT TEACHING POINT
#define LD_UPDN_UNIT_HOME_POS		0  //  ġ //
#define LD_UPDN_UNIT_RECV_POS		1  // GLASS RECEIVE POS
#define LD_UPDN_UNIT_SEND_POS		2  // GLASS SEND POS

// TR_LD Robot Teaching Point
#define UL_HAND_UNIT_HOME_POS			0  //  ġ //
#define UL_HAND_UNIT_BEFORE_RECV_POS	1  // TR Hand Robot ؿ  ϴ ġ //
#define UL_HAND_UNIT_AFTER_RECV_POS		2
#define UL_HAND_UNIT_SEND_POS			3  // TR Hand  Glass ޴ ġ //

#define LD_UP_HAND_Z_SENSOR_START	0
#define LD_UP_HAND_Y_SENSOR_START	5
#define LD_LO_HAND_Z_SENSOR_START	7
#define UL_UP_HAND_Z_SENSOR_START	10
#define UL_UP_HAND_Y_SENSOR_START	15
#define UL_LO_HAND_Z_SENSOR_START	17
#define UP_HAND_Z_SENSOR_NO			5
#define UP_HAND_Y_SENSOR_NO			2
#define LO_HAND_Z_SENSOR_NO			3

#define X_AXIS	0
#define Y_AXIS	1
#define Z_AXIS	2
#define T_AXIS	3

// R/B Position ؼ ΰ  ? // jemoon 
#define RBT_RB_ZERO_POS		0
#define RBT_RB_WAIT_POS		1

// TR TURN UNIT Teaching Point
#define RBT_TR_TURN_HOME_POS		0
#define RBT_TR_TURN_RECV_POS		1		// Glass Transfer Position with Loader Robot
#define RBT_TR_TURN_FW_POS			2		// Process Position
#define RBT_TR_TURN_BW_POS			3
#define RBT_TR_TURN_RETURN_POS		4

// FISH RIB UNIT
#define LD_FISH_UNIT		0
#define UL_FISH_UNIT		1

// ELEVATOR UNIT
#define LD_ELV_UNIT		0	// SanghoCho 2015.03.16

// Ul Cylinder
#define UL_CYL_ALIGN	0
#define UL_CYL_ALIGN_UD	1
#define UL_CYL_PIN_UD	2


// Piping View 
#define MAX_PVIEW1_ION_NO 1
#define MAX_PVIEW2_ION_NO 1

#define MAX_PVIEW1_TANK_NO 1
#define MAX_PVIEW2_TANK_NO 1
#ifdef _BUFTANK_USE
#define MAX_PVIEW3_TANK_NO	1
#endif
#define MAX_PVIEW1_PUMP_NO 2
#define MAX_PVIEW2_PUMP_NO 0
#ifdef _BUFTANK_USE
#define MAX_PVIEW3_PUMP_NO	2
#endif
#define MAX_PVIEW1_SBJ_NO	2 
#define MAX_PVIEW2_SBJ_NO	1

#define MAX_PVIEW1_RB_NO	8
#define MAX_PVIEW2_RB_NO	0

#define MAX_PVIEW1_AI_NO	31
#define MAX_PVIEW2_AI_NO	29
#ifdef _BUFTANK_USE
#define MAX_PVIEW3_AI_NO	6
#endif

#define MAX_PVIEW1_VALVE_NO	10
#define MAX_PVIEW2_VALVE_NO 6
#ifdef _BUFTANK_USE
#define MAX_PVIEW3_VALVE_NO	7
#endif

#define MAX_PVIEW1_AIRK_NO	0
#define MAX_PVIEW2_AIRK_NO	2


// Tank Level : Water Height(mm) * Ratio 
#define DI_TANK_HEIGHT					m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_HH]
#define DI_TANK_LEVEL_HH				m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_HH]
#define DI_TANK_LEVEL_H					m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_H]
//#define DI_TANK_LEVEL_MH				m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_MH]
#define DI_TANK_LEVEL_M					m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_M]
#define DI_TANK_LEVEL_L					m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_L]
//#define DI_TANK_LEVEL_LL				m_pSetupItems->m_nValueTankLevel[CSetupItems::levelDI_TANK_LL]

#define PVIEW1_TANK_HEIGHT(A)		( ( (A) == 0 ) ? DI_TANK_HEIGHT : NULL )
#define PVIEW1_TANK_LEVEL_HH(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_HH : NULL )
#define PVIEW1_TANK_LEVEL_H(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_H : NULL )
#define PVIEW1_TANK_LEVEL_M(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_M : NULL )
#define PVIEW1_TANK_LEVEL_L(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_L : NULL )

#define PVIEW2_TANK_HEIGHT(A)		( ( (A) == 0 ) ? DI_TANK_HEIGHT : NULL )
#define PVIEW2_TANK_LEVEL_HH(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_HH : NULL )
#define PVIEW2_TANK_LEVEL_H(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_H : NULL )
#define PVIEW2_TANK_LEVEL_M(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_M : NULL )
#define PVIEW2_TANK_LEVEL_L(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_L : NULL )

#define PVIEW3_BUFTANK_HEIGHT(A)		( ( (A) == 0 ) ? DI_TANK_HEIGHT : NULL )
#define PVIEW3_BUFTANK_LEVEL_HH(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_HH : NULL )
#define PVIEW3_BUFTANK_LEVEL_H(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_H : NULL )
#define PVIEW3_BUFTANK_LEVEL_M(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_M : NULL )
#define PVIEW3_BUFTANK_LEVEL_L(A)		( ( (A) == 0 ) ? DI_TANK_LEVEL_L : NULL )
#endif	// _DEFINECONSTANT_H