// CommonInterlockSeq.h: interface for the CCommonInterlockSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMONINTERLOCKSEQ_H__BB269B78_6861_4681_BFF8_3888308C49F7__INCLUDED_)
#define AFX_COMMONINTERLOCKSEQ_H__BB269B78_6861_4681_BFF8_3888308C49F7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MOTHER\DicsCommonInterlockSeq.h"
#include "..\FactoryLib\EqpAssy.h"

//////// TIMER PART DEFINE //////// halesu
#define MAX_CVSEQ_NO		2
#define MAX_TIMER_PART_NO	3
///////////////////////////////////

class CCommonInterlockSeq : public CDicsCommonInterlockSeq  
{
public:
	void SeqMjCdaCondition();
	void SetTimerPart( int nPart, BOOL bOn );
	void SeqTimerCondition();
	void SeqPartsCondition( int nPartNo );
	int GetPartsUsedTime( int nPartsNo );
	int GetPartsGlsCount( int nPartsNo );
	void SeqPartsUseTime( int nPartNo );
	void PartsGlsCountIncrease( int nPartsNo );
	void PartsUsedTimeIncrease( int nPartsNo );
	void ResetPartsData( int nPartsNo );
	void SeqAkInterlock();
	CCommonInterlockSeq();
	virtual ~CCommonInterlockSeq();

	int	m_nSeqAreaSensorNo;
	int m_nSeqLdDoorInterlockNo;
	int m_nSeqUlDoorInterlockNo;
	int m_nSeqAkCheckInterlockNo;

	int m_nSeqMjCdaCondNo[2];	// 100908 halesu

	CIniData	m_IniConfiguration;

	///////////////////////////// halesu ////////////////////////////////
	int m_nSeqTimerNo;
	
	enum timerInterlck	{ timerUP_CV, timerLO_CV, timerPUMP };

	struct tagTimerInterlock
	{
		BOOL bCvSeqTimer[MAX_CVSEQ_NO];
		BOOL bPumpSeqTimer;
	} m_Timer;

	struct tagOldTimerInterlock
	{
		BOOL bCvSeqTimer[MAX_CVSEQ_NO];
		BOOL bPumpSeqTimer;
	} m_OldTimer;
	//////////////////////////////////////////////////////////////////////

	BOOL Sequence();
	void InitParameter();

	void SeqAreaSensor();
	void SeqLdDoorInterlock();
#ifndef _NO_UL_HAND
	void SeqUlDoorInterlock();
#endif
	void SeqIonizerCondition();

	BOOL GetPartsCheckCond( int nPartsNo );
	void SeqIFLoaderEmoInterlock();	// SanghoCho 2015.05.04
protected:
	void SeqFfuCondition();
	void SeqDoorSensor();
	void SeqCoverSensor();
	void SeqLeakSensor();
	void SeqRbServoCp();
	void SeqScanDevice();	// 240606 halesu
};

#endif // !defined(AFX_COMMONINTERLOCKSEQ_H__BB269B78_6861_4681_BFF8_3888308C49F7__INCLUDED_)
